// U6BOOKS.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
//#include <stdlib.h>
//#include <conio.h>
#include <string.h>
#include <io.h>
#include <fstream>

// File vars
#define MAX_FILENAME_LENGTH		256
#define MAX_CHAR_LEN			4096

char infname[MAX_FILENAME_LENGTH] = "", outfname[MAX_FILENAME_LENGTH] = "";

FILE *fp;
char *book[129];
int ctr, ctr2;
char *t2, *t3;

short idx[129];
short header[129];
char temp[MAX_CHAR_LEN];

int rebind() {
	char *pdest;

	fp = fopen(infname, "r");
	
	if(!fp) {
		printf("Could not open script file, '%s'\n", infname);
	    return 1;
	}

	printf("Reading books...");

	while(ctr < 130) {
		if(!fgets(temp, MAX_CHAR_LEN, fp)) {
			printf ("\nUnexpected end of file.");
			return 1;
		}
	
		t2 = strchr(temp,']');
	
		if(!t2) {
			printf("\nIndex marker not found..");
			return 1;
		}
	
		*t2 = 0;
		t2 = strchr(temp, '[');

		if(!t2) {
			printf("\nIndex marker not found..");
			return 1;
		}
	
		t2++;

		if(!stricmp(t2, "end")) ctr=130;
		else {
			sscanf(t2, "%d", &ctr);
			ctr--;

			if(!fgets(temp, MAX_CHAR_LEN, fp)) {
				printf("\nUnexpected end of file.");
				return 1;
			}

			book[ctr] = (char*)malloc(strlen(temp) + 3);
			if(!book[ctr]) {
				printf("\nCould not allocate memory for book %d\n", ctr);
				return 1;
			}

			strcpy(book[ctr], temp);

			pdest = strchr(book[ctr], 0xa);
			if (pdest != NULL)
				*pdest = 0;

			pdest = strchr(book[ctr], 0xd);
			if (pdest != NULL)
				*pdest = 0;

			idx[ctr] = strlen(book[ctr]) + 1;

			for(ctr2 = 0; ctr2 < idx[ctr]; ctr2++)
				if(book[ctr][ctr2] == '~') 
					book[ctr][ctr2] = 0xa;
		}
	}

	fclose(fp);

	printf("Building TOC..");

	for(ctr = 0; ctr < 128; ctr++)
		header[ctr] = 0;

	ctr2 = 0x100;

	for(ctr = 0; ctr < 128; ctr++) {
		header[ctr] = ctr2;
		ctr2 += idx[ctr];
	}

	printf("Writing compiled booklist..");

	fp = fopen(outfname, "wb");

	if(!fp) {
		printf("Could not open output file, '%s'\n", outfname);
		return 1;
	}

	fwrite(header, sizeof(short), 128, fp);

	for(ctr = 0; ctr < 128; ctr++)
		fwrite(book[ctr], 1, idx[ctr], fp);

	fclose(fp);
	printf("Done!");

	return 0;
}


int unbind() {

	printf("Reading book datafile...");

	fp = fopen(infname, "rb");

	if(!fp) {
		printf("Could not open book.dat file, '%s'\n",infname);
		return 1;
	}

	fread(header, sizeof(short), 128, fp);
	header[128] = _filelength(_fileno(fp));

	for(ctr = 0; ctr < 128; ctr++) {
		book[ctr] = (char*)malloc((header[ctr + 1] - header[ctr]) + 4);
	
		if(!book[ctr]) {
			printf("Could not allocate memory for book %d\n", ctr);
			return 1;
		}
	}

	for(ctr = 0; ctr < 128; ctr++)
		fread(book[ctr], 1, header[ctr + 1] - header[ctr], fp);

	fclose(fp);

	printf("Writing script file.");

	fp = fopen(outfname,"w");

	if(!fp) {
		printf("Could not open output file, '%s'\n", outfname);
		return 1;
	}

	for(ctr = 0; ctr < 128; ctr++)
		for(ctr2 = 0; ctr2 < strlen(book[ctr]); ctr2++)
			if(book[ctr][ctr2] == 0xa)
				book[ctr][ctr2] = '~';

	for(ctr = 0; ctr < 128; ctr++) {
		fprintf(fp,"[%d]\n", ctr+1);
		fprintf(fp,"%s\n", book[ctr]);
	}

	fprintf(fp, "[end]\n");
	fclose(fp);
	printf("Done!");

	return 0;
}


//////////////////////////////////////////////////////
////////////////// Common functions //////////////////
//////////////////////////////////////////////////////
void print_usage(){

	printf("Ultima 6 Book compiler v1.0\n");
	printf("Copyright (C) 2018 by Lazarus Crystal Dragon &\n");
	printf("(C) 1997 IT-HE Software\n");
	printf("This tool permits:\n");
	printf("  1.- Export to .TXT file a BOOK.DAT file.\n");
	printf("  2.- Create a BOOK.DAT file from .TXT file.\n\n");
	printf("Params:\n");
	printf("  -u  -  For create .TXT file from BOOK.DAT.\n");
	printf("  -r  -  For create BOOK.DAT from .TXT.\n\n");
	printf("Usage:\n");
  	printf(" u6books -u BOOK.DAT BOOK.TXT.\n");
  	printf(" u6books -r BOOK.TXT BOOK.DAT.\n\n");
}

void main(int argc,char *argv[]) {
	int error = 0;

	if (argc == 4) {
		if (argv[1][0] == '-') {
			switch (argv[1][1]) {
				case 'u':
					// This is for Uncompress BYT.ARK.
					strcpy (infname, argv[2]);
					strcpy (outfname, argv[3]);
					error = unbind();
					break;
				case 'r':
					// This is for Extract .BYT files from uncompressed BYT.ARK.
					strcpy (infname, argv[2]);
					strcpy (outfname, argv[3]);
					error = rebind();
					break;
				default:
					print_usage();
			}
		}
		else print_usage();
	}
	else print_usage();

	if (error) printf("Some errors ocurred... try again!");

}