﻿// U6SET.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <fstream>

// File vars
#define MAX_FILENAME_LENGTH		256

char infname[MAX_FILENAME_LENGTH]="", outfname[MAX_FILENAME_LENGTH]="";


long getFileSize(FILE *file) {

	long lCurPos, lEndPos;
    lCurPos = ftell(file);
    fseek(file, 0, 2);
    lEndPos = ftell(file);
    fseek(file, lCurPos, 0);
    return lEndPos;
}


void u6set_create() {
	// Ok, let's put first the file into memory BUT, in binary format.
	// So, we must read it in text format.
	FILE *file = NULL;
	char line[128];
	unsigned short int char_number, width, height, i, j, x;
	unsigned char buffer[20000];
	int old_size, char_size;

	if ((file = fopen(infname, "rb")) == NULL) {
		printf("Could not open specified file.\n");
		return;
	}

	// Let's prepare the buffer.
	buffer[0] = 8;
	buffer[1] = 0;
	buffer[2] = 0xF;
	buffer[3] = 0;

	// First three lines are not interesting.
	fgets(line, 128, file);
	fgets(line, 128, file);
	fgets(line, 128, file);
	fgets(line, 128, file);  // First Char: XX test

	// We will check each line until EOF. Have in mind we have 256 chars.
	// We get the first working line char.
	old_size = 0;
	char_number = 0;
	height = 8;

	while (fgets(line, 128, file) && char_number < 256 ) {
		// Let's see if it is '0', '1', '.'
		if (line[0] == '0') {
			// null character, no data.
			// put width
			width = 0;
			buffer[0x4 + char_number] = width;

			// Ok, let's put high byte and low byte
			// High byte
			buffer[0x204 + char_number] = (((256 * 3) + 0x4) + old_size) / 256;
			// Low byte
			buffer[0x104 + char_number] = (((256 * 3) + 0x4) + old_size) % 256;

			old_size = old_size + (width * height);
		} else {
			if (line[0] == '1') {
				// empty character, only 1 column with 00.
				width = 1;
				buffer[0x4 + char_number] = width;

				// Ok, let's put high byte and low byte
				// High byte
				buffer[0x204 + char_number] = (((256 * 3) + 0x4) + old_size) / 256;
				// Low byte
				buffer[0x104 + char_number] = (((256 * 3) + 0x4) + old_size) % 256;

				// Write character in raw data.
				for (i = 0; i < height; i++) {
					buffer[((256 * 3) + 0x4) + old_size + i] = 0;
				}

				old_size = old_size + (width * height);
			} else {
				if (line[0] == '_') {
					// Let's see the width.
					width = strlen(line) - 2;
					buffer[0x4 + char_number] = width;

					// Ok, let's put high byte and low byte
					// High byte
					buffer[0x204 + char_number] = (((256 * 3) + 0x4) + old_size) / 256;
					// Low byte
					buffer[0x104 + char_number] = (((256 * 3) + 0x4) + old_size) % 256;

					// Write character in raw data. Read 8 lines at least.
					x = 0;
					for (i = 0; i < height; i++) {
						for (j = 0; j < width; j++) {
							if (line[j] == '_') buffer[((256 * 3) + 0x4) + old_size + x] = 0x0;
							else buffer[((256 * 3) + 0x4) + old_size + x] = 0xF;

							x++;
						}

						fgets(line, 128, file);
					}

					old_size = old_size + (width * height);
				}
			}
		}

		//if (line[0] != 0xD && line[0] != 'C') char_number ++;
		if (line[0] == 'C') char_number ++;
	}

	fclose(file);

	// We write buffer data to new U6_NEW.SET file.
	if ((file = fopen(outfname, "wb")) == NULL) {
		printf("Could not open U6_NEW.SET file to write.\n");
		return;
	}

	fwrite(buffer, old_size + (256 * 3) + 0x4, 1, file);
	fclose (file);
}

void u6set_extract() {
	// First we read the file into buffer.
	FILE *file = NULL;
	long fileSize;
	unsigned short int i, x, width, height;
	unsigned char *ch;
	unsigned char buffer[20000];

	if ((file = fopen(infname, "rb")) == NULL) {

		printf("Could not open specified file.\n");
		return;
	}

	fileSize = getFileSize(file);
	fread(buffer, fileSize, 1, file);
	fclose(file);
	

	// Ok, let's output the text file.
	if ((file = fopen(outfname, "wt")) == NULL) {

		printf("Could not open to write specified file.\n");
		return;
	}

	// write some initial text.
	fprintf(file, "U6.SET extracted in text format\n");
	fprintf(file, "-------------------------------\n\n");

	// Ok, write every char in text format.
	// There are a total of 256 chars.
	// For 1 size of width chars, I will put only one column.
	for (i = 0; i < 256; i++) {
		// First write text for the char (only for info)
		fprintf(file, "Char: %03d  (0x%02x)\n", i, i);

		// Write in code the char.  (I will use X for 0x0F and O for 0x00).
		ch = buffer + buffer[0x204 + i] * 256 + buffer[0x104 + i];
		// Height always is 8.
		// We must search Width.
		x = 0;
		height = 8;
		width = buffer[0x4 + i];

		// Width == 1 is NULL char (but we must write it).
		if (width == 0) {
				fprintf(file, "0\n");
		} else {
			if (width == 1) {
				fprintf(file, "1\n");
			} else {
				// Char found.
				while (height > 0) {
					while (width > 0) {
						if (ch[x] == 0xF) {
							fprintf(file, "Û");
						} else {
							fprintf(file, "_");
						}
					
						x ++;
						width --;
					}

					fprintf(file, "\n");
					width = buffer[0x4 + i];
					height --;
				}
			}
		}

		// Next char
		fprintf(file, "\n");
	}

	fclose(file);
}

//////////////////////////////////////////////////////
////////////////// Common functions //////////////////
//////////////////////////////////////////////////////
void print_usage(){

	printf("Ultima VI U6.SET Tool v1.0\n");
	printf("Copyright (C) 2018 by Lazarus Crystal Dragon\n");
	printf("This tool permits:\n");
	printf("  1.- Export to .TXT file an uncompressed U6.SET file.\n");
	printf("  2.- Create an uncompressed U6_NEW.SET file from .TXT.\n\n");
	printf("Params:\n");
	printf("  -x  -  For create .TXT file from U6.SET.\n");
	printf("  -c  -  For create U6.SET file from .TXT.\n\n");
	printf("Usage:\n");
  	printf(" u6set -x U6.SET (extracts U6.TXT).\n");
  	printf(" u6set -c U6.TXT (creates U6.SET).\n\n");
}

void main(int argc, char *argv[])
{
	// buffers vars
	char *buf=NULL;

	// common vars
	int err=0; //error, num_items

	if (argc == 3) {
		if (argv[1][0] == '-') {
			switch (argv[1][1]) {
				case 'x':
					// This is for Uncompress BYT.ARK.
					strcpy (infname, argv[2]);
					strcpy (outfname, "U6.TXT");
					u6set_extract();					
					break;
				case 'c':
					// This is for Extract .BYT files from uncompressed BYT.ARK.
					strcpy (infname, argv[2]);
					strcpy (outfname, "U6_NEW.SET");
					u6set_create();					
					break;
				default:
					print_usage();
			}
		}
		else print_usage();
	}
	else print_usage();
}

